/**
* DO NOT EDIT THIS FILE.
* See the following change record for more information,
* https://www.drupal.org/node/2815083
* @preserve
**/

(function ($, Drupal, drupalSettings) {
  Drupal.color = {
    logoChanged: false,
    callback: function callback(context, settings, $form) {
      if (!this.logoChanged) {
        $('.color-preview .color-preview-logo img').attr('src', drupalSettings.color.logo);
        this.logoChanged = true;
      }

      if (drupalSettings.color.logo === null) {
        $('div').remove('.color-preview-logo');
      }

      var $colorPreview = $form.find('.color-preview');
      var $colorPalette = $form.find('.js-color-palette');

      $colorPreview.find('.preview-content a').css('color', $colorPalette.find('input[name="palette[link-color]"]').val());

      $form.find('.color-preview-header').css('background-color', $colorPalette.find('input[name="palette[brand-primary]"]').val());
      $form.find('.color-preview-header a, .color-preview-header a').css('color', $colorPalette.find('input[name="palette[navbar-inverse-color]"]').val());

      var gradientStart = $colorPalette.find('input[name="palette[btn-primary-top]"]').val();
      var gradientEnd = $colorPalette.find('input[name="palette[btn-primary-bottom]"]').val();
      var gradientVal = $colorPalette.find('input[name="palette[btn-primary-color]"]').val();

      $colorPreview.find('.color-preview-button').attr('style', 'color:' + gradientVal + '; background-color: ' + gradientStart + '; background-image: -webkit-gradient(linear, 0% 0%, 0% 100%, from(' + gradientStart + '), to(' + gradientEnd + ')); background-image: -moz-linear-gradient(-90deg, ' + gradientStart + ', ' + gradientEnd + ');');
    }
  };
})(jQuery, Drupal, drupalSettings);